{**************************************************}
{* Odgadywanie liczby i symulacja rzutow moneta   *}
{* Mensfeld Maciej                                *}
{* 14. 03. 2006                                   *}
{**************************************************}

program odgadywaneLiczbyISymulacjaRzutow;
uses Crt;
const poczatkowa=0;
const koncowa=1000;
type zakres=poczatkowa..koncowa;
var poszukiwana: zakres;
var wybor:byte;
var n, iloscOrlow :word;

procedure start(tytul: string);
begin
 ClrScr;
 Writeln('autor: Mensfeld Maciej');
 Writeln(tytul);
 Writeln;
end;

procedure pobierzLiczbeGra(var poszukiwana :zakres);
begin
 Write('Wprowadz liczbe: ');
 Readln(poszukiwana)
end;

procedure podajWynikGra(var zgadnijLiczbe:zakres);
begin
  Writeln('Poszukiwana liczba wynosi ', zgadnijLiczbe);
end;


procedure pobierzLiczbeRzuty(var n: word);
begin
 Write('Podaj ilosc wykonanych rzutow: ');
 Readln(n);
 ClrScr
end;

function liczbaOrlow(n: word):word;
var licznik, losowa:word;

begin
 Randomize;
 liczbaOrlow := 0;
 for licznik := 1 to n do
 begin
  losowa := Random(2);
  if losowa = 1 then
   liczbaOrlow := liczbaOrlow + 1;
 end
end;

procedure wyprowadzWynikRzuty(var iloscOrlow, n: word);
begin
 iloscOrlow := liczbaOrlow(n);
 Writeln('Ilosc wykonanych rzutow ', n);
 Writeln;
 Writeln('Liczba orlow ', iloscOrlow);
 Writeln;
 Writeln('Ilosc reszek ', n - iloscOrlow);
 Writeln
end;

procedure wyswietlMenu(var wybor:byte);
begin
 Writeln;
 Writeln;
 Writeln('            Oferta:');
 Writeln;
 Writeln('             1.Odgadywanie liczb');
 Writeln('             2.Rzuty moneta');
 Writeln;
 Write('           Twoj wybor: ');
 Repeat
  Readln(wybor);
   if(wybor <> 1) or (wybor <> 2) then
    Write('Wpisz 1 lub 2: ')
 until (wybor = 1) or (wybor = 2);
 ClrScr
end;

procedure wykonajProgram(wybor: byte);
var n: word;
begin
 case wybor of
  1: begin
      pobierzLiczbeGra(poszukiwana);
      podajWynikGra(poszukiwana)
     end;
  2: begin
      pobierzLiczbeRzuty(n);
      wyprowadzWynikRzuty(iloscOrlow, n)
     end
  end
end;



function zgadnijLiczbe(poszukiwana: zakres): zakres;
var srodkowa, poczatek, koniec : zakres;
begin
 poczatek := poczatkowa;
 koniec := koncowa;
 repeat
  srodkowa := (poczatek + koniec) div 2;
  if srodkowa = poszukiwana then
   zgadnijLiczbe := srodkowa
  else
   if srodkowa > poszukiwana then
    koniec := srodkowa - 1
   else
    poczatek := srodkowa + 1;
  until srodkowa=poszukiwana
end;

procedure czekaj;
begin
 Write('Nacisnij klawisz Enter');
 Readln
end;


procedure koniec;
begin
 Writeln;
 Writeln('Koniec');
 czekaj
end;


begin
 start('Odgadywanie liczby i symulacja rzutow moneta');
 wyswietlMenu(wybor);
 wykonajProgram(wybor);
 koniec
end.
