{***********************************}
{* Mensfeld Maciej IIIB            *}
{* 23.02.2007                      *}
{* Szescian odbijajacy sie         *}
{***********************************}

program Szescian;
uses
 Crt, Graph;
var
 sterownik, tryb : integer;
 maxX, maxY : integer;

procedure inicjujModulGraph; { inicjuj modul graficzny ------- }
begin
  sterownik := 0;
  InitGraph(sterownik, tryb, '');
  if GraphResult <> 0 then
   begin
    Writeln('Blad grafiki');
    Halt;
   end;
end; { --------------------------- koniec inicjujModulGraph -- }

procedure ustalRozmiarEkranu(var x, y : integer); { ustala rozmiar ekranu }
begin
 x := GetMaxX;
 y := GetMaxY;
end; { --------------------------- koniec ustalRozmiarEkranu --}

procedure rysuj (x, y, szer, wys : integer; var xP, yP, kPoz, kPion : integer);
begin
 ClearviewPort;
 { jesli ma sie poruszac w prawo to przesun w prawo }
 if kPoz = 0 then
  xP := xP + 10
 { w przeciwnym razie przesun w lewo }
 else
  xP := xP - 10;
 { jesli ma sie poruszac w dol przesun w dol }
 if kPion = 0 then
  yP := yP + 10
 { w przeciwnym razie przesun w gore }
 else
  yP := yP - 10;
 { Rysuj prostokat w oparciu o punkt poczatkowy oraz wysokosc i szerokosc }
 Rectangle(xP, yP, xP + szer, yP + wys);
 { gdy dojdzie do prawego boku ekranu... }
 if xP + szer >= x then
 { "odbij" i przesuwaj w lewo }
  kPoz := 1;
 { gdy dojdzie do lewego boku ekranu... }
 if xP <= 0 then
 { "odbij" i przesuwaj w prawo }
  kPoz := 0;
 { gdy dojdzie do dolu ekranu... }
 if yP + wys >= y then
 { "odbij" i przesuwaj w gore }
  kPion := 1;
 { gdy dojdzie do gory ekranu... }
 if yP <= 0 then
 { odbij i przesuwaj w dol }
  kPion := 0;
 Delay(35); { spowolnij }
end;

procedure poruszaj(x, y : integer); { ------------ poruszaj ---------------}
var
 xP, yP : integer;              { polozenie poczatkowe lewego gornego rogu }
 wys, szer : integer;           { wysokosc i szerokosc prostokata }
 kPoz, kPion : integer;         { kierunek poruszania w pionie i poziomie }
begin
 szer := 50;
 wys := 50;
 xP := 1;                       { rozpocznij od lewego gornego rogu ekranu }
 yP := 1;
 kPoz := 0;                     { zacznij poruszac w prawo oraz w dol }
 kPion := 0;
 repeat { poruszaj prostokatem... }
  rysuj(x,y, szer, wys, xP, yP, kPoz, kPion);
 until keypressed;                   { dopoki nie nacisnie sie klawisza }

end; { ------------------------ koniec poruszaj -------------------------- }

begin

inicjujModulGraph;
ustalRozmiarEkranu(maxX, maxY);
poruszaj(maxX, maxY);
Delay(2000);
CloseGraph;
end.

