{***********************************}
{* Mensfeld Maciej IIIB            *}
{* 23.02.2007                      *}
{* Rysuj okrag z punktow           *}
{***********************************}

program Okrag;
uses
 Crt, Graph;
var
 sterownik, tryb : integer;
 maxX, maxY : integer;

procedure inicjujModulGraph; { inicjuj modul graficzny ------- }
begin
  sterownik := 0;
  InitGraph(sterownik, tryb, '');
  if GraphResult <> 0 then
   begin
    Writeln('Blad grafiki');
    Halt;
   end;
end; { --------------------------- koniec inicjujModulGraph -- }

procedure ustalRozmiarEkranu(var x, y : integer); { ustala rozmiar ekranu }
begin
 x := GetMaxX;
 y := GetMaxY;
end; { --------------------------- koniec ustalRozmiarEkranu --}

procedure rysuj; { ----------- rysujemy ... ---}
var
 licznik : integer;
 x0, y0 : integer; { punkt srodkowy wokol ktorego obracamy figure }
 x, y : integer;    { polozenie punktu na ekranie }
 xr, yr : integer; { odleglosc od punktu srodkowego w osiach OX i OY}
 stopien : real;   { wartosc 1 stopnia }
begin
 x0 := 100;
 y0 := 100;
 xr := 50;
 yr := 50;
 stopien := (2 * Pi / 360); { oblicz wartosc 1 stopnia }
 for licznik := 1 to 360 do { rysuj 360 punktow o stalej odl. od punku srod. }
  begin
   { znajdz wspolrzedne punktu ktory jest o 1 stopien "wyzej" }
   x := Round(x0 + xr * sin(licznik * stopien));
   y := Round(y0 + yr * cos(licznik * stopien));
   Putpixel(x, y, 1); { narysuj ten punkt }
  end;
end;

{ ---------------------------------------- koniec rysuj -}
begin
inicjujModulGraph;
rysuj;
delay(3000);
CloseGraph;
end.

