{**************************************************}
{* Program przeliczajcy wielkosci internetowe    *}
{* Mensfeld Maciej                                *}
{* Data(16,09,2006)                               *}
{**************************************************}

program PrzeliczanieDanychSieciowych;
uses Crt, uPomoce;
var wybor :byte;
    iloscdanych, lacze, czas :real;

procedure zamianaJednostek(wybor: byte);
var KB, Kbit: real;
begin
 if wybor = 1 then
  begin
   Gotoxy(25,2);
   Write('Podaj ilosc kilobajtow: ');
   Readln(KB);
   Kbit := KB * 8;
   if Kbit > 1024 then
    begin
     Gotoxy(25,2);
     Delline;
     Writeln(KB :8:1, ' KB = ' ,(Kbit / 1024) :4:1, ' Mbit.')
    end
   else
    begin
     Gotoxy(25,2);
     Delline;
     Writeln(KB :6:1, ' KB = ', Kbit :8:1, ' Kbit')
    end
  end
 else
  if wybor = 2 then
   begin
    Gotoxy(25,2);
    Write('Podaj ilosc kilobitow: ');
    Readln(Kbit);
    KB := Kbit / 8;
    if KB > 1023 then
     begin
      Gotoxy(25,2);
      Delline;
      Writeln(Kbit:6:1, ' Kbit = ', (KB / 1024) :4:1, ' MB');
     end
    else
     begin
      Gotoxy(25,2);
      Delline;
      Writeln(Kbit:6:1, ' Kbit = ', KB :4:1, ' KB');
     end
   end
  else
   if wybor = 3 then
    begin
     Gotoxy(25,2);
     Write('Podaj ilosc kilobajtow: ');
     Readln(KB);
     Gotoxy(25,2);
     Delline;
     Write(KB :6:0, ' Kb = ',(KB/1024) :5:2, ' MB');
    end
   else
    begin
     Gotoxy(25,2);
     Write('Podaj ilosc megabajtow: ');
     textcolor(15);
     Readln(KB);
     Gotoxy(25,2);
     Delline;
     Writeln(KB :6:0, ' MB = ',(KB * 1024) :8:1, ' KB')
    end
end;

procedure czasTransferu(iloscdanych, lacze, czas: real);
begin
 Gotoxy(18,2);
 Write('Podaj przepustowosc lacza (w kilobitach): ');
 Readln(lacze);
 Gotoxy(19,4);
 Write('Podaj ilosc danych do przeslania (w MB): ');
 Readln(iloscdanych);
 czas := (iloscdanych * 1024) / (lacze / 8);
 if czas > 59 then
  begin
   Gotoxy(21,6);
   Writeln('Czas potrzebny na przeslanie ', iloscdanych :4:2, ' MB');
   Gotoxy(13,8);
   Write('przez lacze o przepustowosci ', lacze :6:0, 'Kbit');
   Writeln(' wynosi: ', (czas / 60) :4:1,' min')
  end
 else
  begin
   Gotoxy(21,6);
   Writeln('Czas potrzebny na przeslanie ', iloscdanych :4:2, ' MB');
   Gotoxy(17,8);
   Write('przez lacze o przepustowosci ', lacze :6:1);
   Writeln(' wynosi: ', czas :4:1, ' s')
  end
end;

procedure predkoscLacza(iloscdanych, lacze, czas :real);
begin
 Gotoxy(17,2);
 Write('Podaj czas (w minutach) przesylania pliku: ');
 Readln(czas);
 Gotoxy(16,4);
 Write('Podaj ilosc przeslanych danych (w megabajtach): ');
 Readln(iloscdanych);
 lacze := (iloscdanych * 8192) / (czas * 60);
 if lacze > 1023 then
  begin
   Gotoxy(21,6);
   Writeln('Predkosc lacza wynosi: ', (lacze / 1024) :4:1, ' Mbit/s');
  end
 else
  begin
   Gotoxy(23,6);
   Writeln('Predkosc lacza wynos: ', lacze :4:0, ' Kbit/s');
  end
end;

procedure iloscPrzeslanychDanych(iloscdanych, lacze, czas :real);
begin
Gotoxy(19,2);
 Write('Podaj czas przesylu danych (w minutach): ');
 Readln(czas);
 Gotoxy(21,4);
 Write('Podaj predkosc lacza (w kilobitach): ');
 Readln(lacze);
 iloscDanych := (lacze * (czas * 60)) / 8;
 if iloscDanych > 1023 then
  begin
  Gotoxy(22,6);
   Writeln('Ilosc przeslanych danych to ', (iloscDanych / 1024) :4:1, ' MB');
  end
 else
  begin
  Gotoxy(22,6);
   Writeln('Ilosc przeslanych danych to ', iloscDanych :8:1, ' KB');
  end
end;

procedure wyswietlMenu(var wybor:byte);
begin
 Gotoxy(7,4);
 textcolor(15);
 Writeln('Opcje:');
 Writeln;
 Textcolor(15);
 Write('       1');
 Textcolor(7);
 Writeln('.Kilobajty --> Kilobity');
 Textcolor(15);
 Write('       2');
 Textcolor(7);
 Writeln('.Kilobity  --> Kilobajty');
 Textcolor(15);
 Write('       3');
 Textcolor(7);
 Writeln('.Kilobajty --> Megabajty');
 Textcolor(15);
 Write('       4');
 Textcolor(7);
 Writeln('.Megabajty --> Kilobajty');
 Textcolor(15);
 Write('       5');
 Textcolor(7);
 Writeln('.Czas transferu danych w zaleznosci od predkosci lacza i ilosci danych.');
 Textcolor(15);
 Write('       6');
 Textcolor(7);
 Writeln('.Predkosc lacza w zaleznosci od czasu i  ilosci przeslanych danych.');
 Textcolor(15);
 Write('       7');
 Textcolor(7);
 Writeln('.Ilosc przeslanych danych w zaleznosci od predkosci lacza i czasu.');
 Textcolor(15);
 Writeln;
 Write('       0');
 Textcolor(7);
 Write('.Aby zakonczyc dzialanie programu.');
 Textcolor(7);
 Writeln;
 Writeln;
 Write('           Twoj wybor: ');
 Repeat
  Textcolor(15);
  Readln(wybor);
   if(wybor < 0) or (wybor > 7) then
    Gotoxy(2,16);
    Delline;
    Textcolor(red);
    Write('          Wpisz poprawna wartosc: ');
 until (wybor >= 0) and (wybor < 8);
 Clrscr;
end;

procedure wykonajProgram(wybor: byte);
begin
 Textcolor(7);
 case wybor of
  1..4: zamianaJednostek(wybor);
  5: czasTransferu(iloscdanych, lacze, czas);
  6: predkoscLacza(iloscdanych, lacze, czas);
  7: iloscPrzeslanychDanych(iloscdanych, lacze, czas);
  0: ;
 end
end;

procedure czyZakonczyc(var wybor: byte);
begin
 if wybor = 0 then
  exit
 else
  Gotoxy(4,12);
  Writeln('Nacisnij i zatwierdz klawiszem enter: ');
  Gotoxy(15,14);
  Textcolor(15);
  Write('1');
  Textcolor(7);
  Writeln('.Aby zakonczyc.');
  Gotoxy(15,16);
  Textcolor(15);
  Write('2');
  Textcolor(7);
  Writeln('.Aby powrocic do menu wyboru.');
  Gotoxy(15,18);
  Write('Twoj wybor: ');
  Repeat
   Textcolor(15);
   Readln(wybor);
    if(wybor < 1) or (wybor >=2) then
     Gotoxy(2,18);
     Delline;
     Textcolor(red);
     Write('          Wpisz poprawna wartosc: ');
  until (wybor = 1) or (wybor = 2);
  case wybor of
   1: ;
   2: begin
       Textcolor(7);
       start('Program przeliczajacy wielkosci internetowe.');
       wyswietlMenu(wybor);
       wykonajProgram(wybor);
       czyZakonczyc(wybor)
      end
  end
end;

begin
 start('Program przeliczajacy wielkosci internetowe.');
 wyswietlMenu(wybor);
 wykonajProgram(wybor);
 czyZakonczyc(wybor);
end.

