{***********************************}
{* Mensfeld Maciej IIIB            *}
{* 23.02.2007                      *}
{* Wygaszacz ekranu                *}
{***********************************}

unit uWygaszacz;
interface

procedure wygaszacz(x, y : integer);

implementation
uses Crt, Graph;

procedure wygaszacz(x, y : integer);
var
 licznik : integer;
 xLewy, xPrawy : integer;
 yGora, yDol : integer;
 kolor, wypelnienie : integer; { kolor oraz sposob wypelnienia figury }
 figura : byte;  { okresla ktora z figur bedzie narysowana --> case of }
 r : integer; { promien kola }
begin
 Randomize;
 licznik := 0; { zerowanie licznika }
 repeat { ------------------------------------------- powtarzaj dopoki ... }
  xLewy := Random(x - 8) + 4;
  xPrawy := Random(x - xLewy) + xLewy;
  yGora := Random(y - 8) + 4;
  yDol := Random(y - yGora) + yGora + 1;
  kolor := Random(16); { wylosuj kolor }
  Setcolor(kolor); { ustaw kolor w jakim beda rysowane elementy }
  figura := Random(3); { losuj figure (prostokat lub okrag) }
  wypelnienie := Random(12);
  SetFillStyle(wypelnienie , kolor); { ustaw styl wypelnienia }
  case figura of { gdy  figura = ...}
  { rysuj prostokat i wypelnij go }
  0 : begin
       Rectangle(xLewy , yGora  ,xPrawy, yDol); { rysuj }
       FloodFill(xLewy + 1,yGora + 1, kolor); { wypelnij prostokat }
      end;
  { rysuj okrag i wypelnij go }
  1 : begin
       r := Random((x div 2) - 2); { ustal promien okregu }

       { jesli okrag bedzie wychodzil poza ekran w osi OX }
       while ((xLewy - r) <= 2) or ((xLewy + r) >= x) do
       { znajdz taki promien dla ktorego nie wyjdzie poza ekran w osi OX }
        r := Random(x div 2) + 1;

       { jesli okrag bedzie wychodzil poza ekran w osi OY }
       while ((yGora - r) <= 2) or ((yGora + r) >= y) do
       { znajdz taki promien dla ktorego nie wyjdzie poza ekran w osi OY }
        r := Random(x div 2) + 1;

       Circle(xLewy, yGora, r); { rysuj okrag }
       FloodFill(xLewy + 1, yGora + 1, kolor); { wypelnij okrag }
      end;
  { rysuj juz wypelniony czworokat }
  2 : begin
       bar(xLewy, yGora, xPrawy, yDol);
       delay(500); { zatrzymaj dzialanie programu na 500 milisekund }
      end;
  end;
  Inc(licznik); { powieksz licznik o 1 }
  if licznik = 20 then { jesli na ekranie 10 figur to ... }
   begin
    ClearViewPort; { ... wyczysc ekrani ... }
    licznik := 0;  { zeruj licznik }
   end;
 until licznik = 19; { ---------------------------------- ... dopoki XXX -- }
 Delay(3000);
end;
end.

