{*******************************}
{* Mensfeld Maciej             *}
{* 08.03.2007                  *}
{* Wybor roznych animacji      *}
{*******************************}

program ProstokatIOkregi;
uses
 Crt, Graph,
 uProstokaty, uGrafika, uWygaszacz, uCzworokat, uSzescian, uFigury;
var
 sterownik, tryb : integer;
 maxX, maxY : integer; { dwa krancowe punkty }
 wybor : integer;      { numer animacji }

{ ---------------------------- INICJUJ MODUL GRAPH ------------------------ }
procedure inicjujModulGraph;  { inicjuj modul graficzny }
begin
 sterownik:=0;
 InitGraph(sterownik, tryb, '');
 if GraphResult <> 0 then
  begin
   Writeln('Blad grafiki'); { wyswietl blad }
   Halt;
  end;
end;
{ ---------------------------- KONIEC INICJUJ MODUL GRAPH ----------------- }

{ ---------------------------- USTAL ROZMIAR EKRANU ----------------------- }
procedure ustalRozmiarEkranu(var x , y : integer);
begin
 x := GetMaxX;
 y := GetMaxY;
end;
{ ---------------------------- KONIEC USTAL ROZMIAR EKRANU ---------------- }

{ ---------------------------- WYSWIETL MENU ------------------------------ }
procedure wyswietlMenu(x, y : integer);
begin
 settextstyle(1,horizdir,2); { ustal styl tekstu (czcionka, poziom, rozmiar)}
 OutTextXY(x div 2 - 300, y div 2 - 200, 'Wybor: ');
 OutTextXY(x div 2 - 200, y div 2 - 150 , '1. Kompozycja prostokatow ');
 OutTextXY(x div 2 - 200, y div 2 - 100 , '2. Napis "GRAFIKA"');
 OutTextXY(x div 2 - 200, y div 2 - 50 , '3. Wygaszacz ');
 OutTextXY(x div 2 - 200, y div 2, '4. Animacja prostokata ');
 OutTextXY(x div 2 - 200, y div 2 + 50 , '5. Obrotowy szescian ');
 OutTextXY(x div 2 - 200, y div 2 + 100 , '6. Ruchome figury ');
 OutTextXY(x div 2 - 300, y div 2 + 300 , '0. Wyjscie ');
 delay(6500);
end;
{ ---------------------------- KONIEC WYSWIETL MENU ----------------------- }

{ ---------------------------- DOKONAJ WYBORU ----------------------------- }
procedure dokonajWyboru(var numer : integer);
begin
 CloseGraph;
 ClrScr;
 GotoXY(10,20); { skocz do 10 , 20 }
 Write('Dokonaj wyboru : ');
 GotoXY(27, 20);
 Read(numer);   { czytaj numer animacji }
 while (numer < 0) or (numer > 7) do { jesli niezgodny z menu }
  begin
   GotoXY(10, 20); { skocz do 10, 20 }
   ClrEol;         { wyczysc linijke }
   Write('Bledny wybor. Wybierz ponownie : ');
   GotoXY(43, 20);
   Read(numer);
  end;
end;
{ ---------------------------- KONIEC DOKONAJ WYBORU ---------------------- }

{ ---------------------------- RYSUJ -------------------------------------- }
procedure rysuj(x, y, numer : integer);
begin
 case numer of { w zaleznosci od wybranej opcji narysuj }
  1 : begin
       InicjujModulGraph;
       prostokatyWRogach(x, y);
      end;
  2 : begin
       InicjujModulGraph;
       grafika;
       CloseGraph
      end;
  3 : begin
       InicjujModulGraph;
       wygaszacz(x, y);
      end;
  4 : begin
       InicjujModulGraph;
       czworokat(x, y);
      end;
  5 : begin
       InicjujModulGraph;
       szescian(1);
      end;
  6 : begin
       InicjujModulGraph;
       figury(x, y);
      end;
  0 : halt;
 end;
end;
{ --------------------------- KONIEC RYSUJ -------------------------------- }

begin
 InicjujModulGraph;
 ustalRozmiarEkranu(maxX, maxY);
 wyswietlMenu(maxX, maxY);
 dokonajWyboru(wybor);
 rysuj(maxX, maxY, wybor);
end.

