{**************************************************}
{* Porzadkowanie liczb - Selection Sort           *}
{* Mensfeld Maciej                                *}
{* Data(01,06,2006)                               *}
{**************************************************}

program PorzadkowanieLiczb;
uses  uPomoce,Crt;
const n = 4;
type tabReal1n = array[1..n] of byte;
var x: tabReal1n;
var pierwsza, druga, trzecia, czwarta: word;
var indeks: byte;

procedure czytajDane(var pierwsza, druga, trzecia, czwarta: word);
begin
 write('Podaj cztery dowolne liczby oddzielajac je spacjami: ');
 Readln(pierwsza, druga, trzecia, czwarta);
 Clrscr
end;

procedure stworzTablice;
var licznik: byte;
begin
  x[1] := pierwsza;
  x[2] := druga;
  x[3] := trzecia;
  x[4] := czwarta;
end;

function min(n: byte; x: tabReal1n; indeks: byte): byte;
var minimum: real;
licznik: byte;
indeksMin: byte;
begin
 minimum := x[indeks];
 for licznik:= indeks + 1 to n do
  if x[licznik] < minimum then
   begin
    minimum :=x[licznik];
    indeks := licznik;
   end;
  min := indeks
end;

procedure selectionSort(n: byte; var x: tabReal1n);
var licznik: byte;
var schowek: byte; var indeksMin:byte;
begin
 indeks := 1;
 for licznik:=1 to n-1  do
  begin
   indeksMin := min(n,x,indeks);
   schowek := x[indeksMin];
   x[indeksMin] := x[licznik];
   x[licznik] := schowek;
   indeks := indeks + 1
  end
end;

procedure wypiszLiczby;
begin
 Writeln;
 Writeln('Podane liczby w kolejnosci od najmniejszej do najwiekszej:');
 Writeln;
 Writeln(x[1]);
 Writeln(x[2]);
 Writeln(x[3]);
 Write(x[4])
end;

begin
 start('Porzadkowanie liczb z wykorzystaniem algorytmu SelectionSort');
 czytajDane(pierwsza, druga, trzecia, czwarta);
 stworzTablice;
 selectionSort(n,x);
 wypiszLiczby;
 koniec;
 czekaj;
end.





