{*******************************}
{* Mensfeld Maciej             *}
{* 22.02.2007                  *}
{* Rysowanie okregow           *}
{*******************************}

program ProstokatIOkregi;
uses
 Crt, Graph;
var
 sterownik, tryb : integer;
 maxX, maxY : integer; { dwa krancowe punkty }
const
 R = 40; { promien okregow }
 ILOSC = 6; { ilosc okregow }

procedure inicjujModulGraph;  { inicjuj modul graficzny }
begin
 sterownik:=0;
 InitGraph(sterownik, tryb, '');
 if GraphResult <> 0 then
  begin
   Writeln('Blad grafiki'); { wyswietl blad }
   Halt;
  end;
end;

procedure ustalRozmiarEkranu(var x , y : integer);
begin
 x := GetMaxX;
 y := GetMaxY;
end;

procedure rysuj(x, y : integer); { rysuj prostokat oraz okregi }
var
 licznik, polS : integer; { polS - polozenie okregu wzgledem X }
 poczatekX, poczatekY : integer;
begin
 poczatekX := (x div 2 ); { srodek ekranu (os OX) }
 poczatekY := (y div 2) - 200;  { srodek ekranu (os OY) }
 Setcolor(0);
 OutTextXY(poczatekX - 60, 100 ,' Mensfeld Maciej'); { wyswietl tekst }
 Rectangle(poczatekX - (ILOSC * R), poczatekY,
           poczatekX + (ILOSC * R), poczatekY + (2 * R));
 polS := 0; { inicjuj polozenie  poczatkowe srodka okregu wzgledem OX }
 for licznik := 0 to ILOSC - 1 do { rysuj okregi }
  begin
   Setcolor(licznik+1);
   Circle(poczatekX - (ILOSC * R) + R + polS, poczatekY + R, R); { koleczko }
   polS := polS + 2 * R { przesun o srednice w OX }
  end;
end;

begin
 inicjujModulGraph;
 ustalRozmiarEkranu(maxX, maxY);
 rysuj(maxX, maxY);
 delay(3000);
end.
